﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Media;

namespace CustomizedList
{

    class FileItem : DependencyObject
    {

        public string FileName
        {
            get { return (string)GetValue(FileNameProperty); }
            set { SetValue(FileNameProperty, value); }
        }
        public static readonly DependencyProperty FileNameProperty =
            DependencyProperty.Register("FileName", typeof(string), typeof(FileItem), 
                                        new UIPropertyMetadata(string.Empty));



        public bool IsBiggerFile
        {
            get { return (bool)GetValue(IsBiggerFileProperty); }
            private set { SetValue(IsBiggerFileProperty, value); }
        }
        public static readonly DependencyProperty IsBiggerFileProperty =
            DependencyProperty.Register("IsBiggerFile", typeof(bool), typeof(FileItem), 
                                        new UIPropertyMetadata(false));



        public float KBSize
        {
            get { return (float)GetValue(KbSizeProperty); }
            set {
                    if (value > 1000)
                        IsBiggerFile = true;
                    else
                        IsBiggerFile = false;

                    SetValue(KbSizeProperty, value); 
                }
        }
        public static readonly DependencyProperty KbSizeProperty =
            DependencyProperty.Register("KbSize", typeof(float), typeof(FileItem), 
                                    new UIPropertyMetadata((float)0));

        public string FileExtension
        {
            get { return (string)GetValue(FileExtensionProperty); }
            set { SetValue(FileExtensionProperty, value); }
        }
        public static readonly DependencyProperty FileExtensionProperty =
            DependencyProperty.Register("FileExtension", typeof(string), typeof(FileItem), 
                                new UIPropertyMetadata(string.Empty));

        public string BorderColor
        {
            get { return (string)GetValue(BorderColorProperty); }
            set { SetValue(BorderColorProperty, value); }
        }
        public static readonly DependencyProperty BorderColorProperty =
            DependencyProperty.Register("BorderColor", typeof(Brush), typeof(FileItem),
                                        new UIPropertyMetadata(Brushes.Blue));


        public override string ToString()
        {
            return "Item: " + FileName;
        }
    }
}
