﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using System.IO;
using System.Xml.Schema;
using System.Xml;
using System.Xml.Serialization;
using Infragistics.Windows.DataPresenter;
using Infragistics.Windows.Editors;

namespace CustomizedList
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        ObservableCollection<FileItem> myFileCollection
        {
            get { return (ObservableCollection<FileItem>)GetValue(myFileCollectionProperty); }
            set { SetValue(myFileCollectionProperty, value); }
        }

        public ObservableCollection<ColumnInfo> Columns
        {
            get { return (ObservableCollection<ColumnInfo>)GetValue(ColumnsProperty); }
            set { SetValue(ColumnsProperty, value); }
        }

        // Using a DependencyProperty as the backing store for Columns.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty ColumnsProperty =
            DependencyProperty.Register("Columns", typeof(ObservableCollection<ColumnInfo>), typeof(Window1), new UIPropertyMetadata(new ObservableCollection<ColumnInfo>()));

        // Using a DependencyProperty as the backing store for myFileCollection.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty myFileCollectionProperty =
            DependencyProperty.Register("myFileCollection", typeof(ObservableCollection<FileItem>), typeof(Window1), new UIPropertyMetadata(new ObservableCollection<FileItem>()));

        public Window1()
        {
            this.DataContext = this;
            
            InitializeComponent();

            PopualateCollection();
           
            //ColumnsDefinitions configuredColumns = ReadConfiguredColumns();
            Columns =  GetColumnInfo();

            CreateCostumizedColumns(Columns);

            //xamGrid.DataSource = myFileCollection;
        }

        private void CreateCostumizedColumns(ObservableCollection<ColumnInfo> configuredColumns)
        {      

            //foreach (ColumnDefinition col in configuredColumns.ColumnDefinition)
            //{
            //    GridViewColumn gridColumn = new GridViewColumn();

            //    FrameworkElementFactory contentControlFactory = 
            //                                new FrameworkElementFactory(typeof(ContentControl));
            //    Style confStyle = this.FindResource(col.CellStyle.ToString()) as Style;
            //    contentControlFactory.SetValue(ContentControl.StyleProperty, confStyle);

            //    if (col.CellStyle != CellStyles.KBSizeIcon &&
            //        col.CellStyle != CellStyles.IconFileType)
            //    {
            //        Binding binding = new Binding(col.Column.ToString());
            //        contentControlFactory.SetBinding(ContentControl.ContentProperty, binding);
            //    }

            //    gridColumn.Header = col.Column.ToString();
            //    gridColumn.CellTemplate = new DataTemplate();
            //    gridColumn.CellTemplate.VisualTree = contentControlFactory;

            //    myGridView.Columns.Add(gridColumn);
            //}

            FieldLayout fieldLayout = new FieldLayout();

            Field field;

             FrameworkElementFactory contentControlFactory ;

            foreach (ColumnInfo col in Columns)
            {
                field = new Field(col.Name);
                field.Label = col.Name;

                field.Width = new FieldLength(100, FieldLengthUnitType.Auto);

               // contentControlFactory  = new FrameworkElementFactory(typeof(CellValuePresenter));

                if (col.Type == DisplayType.TextBox)
                {
                    FieldSettings fs = new FieldSettings();
                    Style checkStyle = new Style(typeof(CellValuePresenter));

                    ControlTemplate checkTemp = new ControlTemplate(typeof(CellValuePresenter));
                    FrameworkElementFactory checkFact = new FrameworkElementFactory(typeof(TextBox));

                    //checkFact.SetBinding(TextBox.IsEnabledProperty, new Binding("DataPresenter.FieldSettings.AllowEdit")
                    //{
                    //    Mode = BindingMode.TwoWay,
                    //    RelativeSource = RelativeSource.TemplatedParent
                    //});

                    checkFact.SetBinding(TextBox.TextProperty, new Binding("Value")
                    {
                        Mode = BindingMode.TwoWay,
                        RelativeSource = RelativeSource.TemplatedParent
                    });

                    checkFact.SetBinding(TextBox.BackgroundProperty, new Binding(col.BorderColor.ToString())
                    {
                        Mode = BindingMode.TwoWay,
                        RelativeSource = RelativeSource.TemplatedParent
                    });

                    checkStyle.Setters.Add(new Setter(CellValuePresenter.TemplateProperty, checkTemp));

                    checkTemp.VisualTree = checkFact;

                    field.Settings.CellValuePresenterStyle = checkStyle;
                }     
                fieldLayout.Fields.Add(field);
            }

            xamGrid.FieldLayouts.Add(fieldLayout);
        }

        private ObservableCollection<ColumnInfo> GetColumnInfo()
        {
            ObservableCollection<ColumnInfo> coulmns = new ObservableCollection<ColumnInfo>();
            ColumnInfo c1, c2, c3, c4, c5;

            //TestDataSource t1 = new TestDataSource();

            //c1 = new ColumnInfo("Name", DisplayType.TextBlock);
            //c2 = new ColumnInfo("Description", DisplayType.TextBlock);
            //c3 = new ColumnInfo("SRLoLimit", DisplayType.Button);
            //c4 = new ColumnInfo("Status", DisplayType.ComboBox);
            c5 = new ColumnInfo("Value", DisplayType.TextBox);

            //coulmns.Add(c1);
            //coulmns.Add(c2);
            //coulmns.Add(c3);
            //coulmns.Add(c4);
            coulmns.Add(c5);

            return coulmns;
        }

        private void PopualateCollection()
        {
            for (int i = 0; i < 2; i++)
            {
                string fileExtension = ".jpg";
                string fileName = "document";
                float fileSize = 350 * i;

                if (i % 2 == 0)
                    fileExtension = ".pdf";
                if (i % 3 == 0)
                    fileExtension = ".doc";

                fileName += fileExtension;

                myFileCollection.Add(new FileItem()
                {
                    FileExtension = fileExtension,
                    FileName = fileName,
                    KBSize = fileSize,
                    //BorderColor = Brushes.Red
                });
            }
        }
    }
}
